#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <linux/types.h>
#include <ctype.h>
#include <string.h>

#include "lblib.h"

#define LOCAL_OFFSET 0x0
#define LOCAL_SIZE   0x10000
#define TRUE 1
#define FALSE 0

int error = 0;

int main(void)
{
    FILE *fp,*fp1;
    int i,j=0,n;
    u_int32_t ffull,fempty,freadw;
    printf("\n\n");
    if (lb_init(LOCAL_OFFSET, LOCAL_SIZE)) 
    {
		perror("local bus init");
		exit(errno);
    }
    if ((fp=fopen("fifowrite.dat","w"))==NULL) {
	printf("Error opening file!");
	return 0; }
    if ((fp1=fopen("fiforead.dat","w"))==NULL) {
	printf("Error opening file!");
	return 0; }
    printf("Insert the number of read/write : ");
    scanf("%d",&n);
    printf("\nThinking... Please wait...");
    for (i=1;i<=n;i++)
    {
	while(lb_read_word(0x1014, &ffull)!=X"23")
	{
	    if(i%2) {
		lb_write_word(0x1030,0xaaaaaaaa);
		fprintf(fp,"aaaaaaaa"); }
	    else {
		lb_write_word(0x1030,0x55555555); 
		fprintf(fp,"55555555"); } 
	}
	printf("%h",&ffull);
	while(lb_read_word(0x1014, &fempty)!=X"23")
	{
	    lb_read_word(0x101C, &freadw);
	    fprintf(fp,"%d\n",&freadw); 
	}	
//	printf("%h%d",&fempty,&freadw);
    }
    fclose(fp);
    fclose(fp1);
    if ((fp=fopen("fifowrite.dat","r"))==NULL) {
	printf("Error opening file!");
	return 0; }
    if ((fp1=fopen("fiforead.dat","r"))==NULL) {
	printf("Error opening file!");
	return 0; }
    while(fscanf(fp,"%d",&word1)!=EOF)
    {
	fscanf(fp1,"%d",&word2);
	if(word1!=word2)
	    j++;	    
    }
    fclose(fp);
    fclose(fp1);
    printf("\nTest finished! %d errors over %d cycles",&j,&n);
    printf("\n\n");
    return 1;
}

